!*****************************************************************************/
!*  Copyright (C) NEC Corporation 2015 All rights reserved.                  */
!*  File Name    : SGTK_f.h                                                  */
!*  Abstract     : I/O toolkit header file for fortran                       */
!*                                                                           */
!*  Author     NEC                                                           */
!*  Date       2015/03/20                                                    */
!*  Version    1.00                                                          */
!*  Notice                                                                   */
!*****************************************************************************/

!*****************************************************************************/
!* data type define                                                          */
!*****************************************************************************/
      integer,PARAMETER :: SGTK_H5T_STD_I8_TYPE=0
      integer,PARAMETER :: SGTK_H5T_STD_U8_TYPE=1
      integer,PARAMETER :: SGTK_H5T_STD_I16_TYPE=2
      integer,PARAMETER :: SGTK_H5T_STD_U16_TYPE=3
      integer,PARAMETER :: SGTK_H5T_STD_I32_TYPE=4
      integer,PARAMETER :: SGTK_H5T_STD_U32_TYPE=5
      integer,PARAMETER :: SGTK_H5T_STD_I64_TYPE=6
      integer,PARAMETER :: SGTK_H5T_STD_U64_TYPE=7
      integer,PARAMETER :: SGTK_H5T_IEEE_F32_TYPE=8
      integer,PARAMETER :: SGTK_H5T_IEEE_F64_TYPE=9
      integer,PARAMETER :: SGTK_H5T_C_S1_TYPE=10

!*****************************************************************************/
!* kind of value (radiance/reflectance/other).                               */
!*****************************************************************************/
      integer,PARAMETER :: SGTK_KIND_RADIANCE=0
      integer,PARAMETER :: SGTK_KIND_REFLECTANCE=1
      integer,PARAMETER :: SGTK_KIND_OTHER=3

!*****************************************************************************/
!* file open mode.                                                           */
!*****************************************************************************/
      integer,PARAMETER :: IOTK_ON=1
      integer,PARAMETER :: IOTK_OFF=0

      integer,PARAMETER :: SUCCESS=0
      integer,PARAMETER :: FAIL=(-1)
      integer,PARAMETER :: ERROR_FILE_OPEN=(-100)
      integer,PARAMETER :: ERROR_MALLOC=(-101)
      integer,PARAMETER :: ERROR_ENV_NAME=(-102)
      integer,PARAMETER :: ERROR_LEAP_SEC=(-103)
      integer,PARAMETER :: ERROR_DIR_OPEN=(-104)
      integer,PARAMETER :: ERROR_FILE_READ=(-105)
      integer,PARAMETER :: ERROR_FILE_CLOS=(-106)
      integer,PARAMETER :: ERROR_FILE_SEQ=(-107)
      integer,PARAMETER :: ERROR_FILE_SIZE=(-108)
      integer,PARAMETER :: ERROR_GEOPHSICAL_FILE=(-109)

      integer,PARAMETER :: ERROR_ILLEGAL_YEAR=(-201)
      integer,PARAMETER :: ERROR_ILLEGAL_MONTH=(-202)
      integer,PARAMETER :: ERROR_ILLEGAL_DAY=(-203)
      integer,PARAMETER :: ERROR_ILLEGAL_HOUR=(-204)
      integer,PARAMETER :: ERROR_ILLEGAL_MIN=(-205)
      integer,PARAMETER :: ERROR_ILLEGAL_SEC=(-206)
      integer,PARAMETER :: ERROR_ILLEGAL_MS=(-207)
      integer,PARAMETER :: ERROR_ILLEGAL_DATE=(-208)
      integer,PARAMETER :: ERROR_ILLEGAL_TOTALSEC=(-209)
      integer,PARAMETER :: ERROR_ILLEGAL_FILENAME=(-210)
      integer,PARAMETER :: ERROR_ILLEGAL_SCANNUM_S=(-211)
      integer,PARAMETER :: ERROR_ILLEGAL_SCANNUM_E=(-212)
      integer,PARAMETER :: ERROR_ILLEGAL_HDF_FILEID=(-213)
      integer,PARAMETER :: ERROR_ILLEGAL_INDEX=(-214)
      integer,PARAMETER :: ERROR_ILLEGAL_DIMS=(-215)
      integer,PARAMETER :: ERROR_NOT_WRITEDATA=(-216)
      integer,PARAMETER :: ERROR_NOT_ACCESSLABEL=(-217)
      integer,PARAMETER :: ERROR_ACCESSLABEL_WRITE_NG=(-218)
      integer,PARAMETER :: ERROR_ACCESSLABEL_READ_NG=(-219)
      integer,PARAMETER :: ERROR_MEMSIZE=(-220)
      integer,PARAMETER :: ERROR_NULL_ADDRESS=(-221)
      integer,PARAMETER :: ERROR_ILLEGAL_METADATA=(-222)
      integer,PARAMETER :: ERROR_ILLEGAL_TFLG=(-223)
      integer,PARAMETER :: ERROR_ILLEGAL_PRMG=(-224)
      integer,PARAMETER :: ERROR_ILLEGAL_PRMA=(-225)
      integer,PARAMETER :: ERROR_ILLEGAL_LEV=(-226)
      integer,PARAMETER :: ERROR_ILLEGAL_LAT=(-227)
      integer,PARAMETER :: ERROR_ILLEGAL_LON=(-228)
      integer,PARAMETER :: ERROR_ILLEGAL_IFLG=(-229)
      integer,PARAMETER :: ERROR_NOT_TARGET_FILE=(-230)
      integer,PARAMETER :: ERROR_ILLEGAL_SECTIONNO=(-231)
      integer,PARAMETER :: ERROR_ILLEGAL_NPIX=(-232)
      integer,PARAMETER :: ERROR_ILLEGAL_HEIGHT=(-233)
      integer,PARAMETER :: ERROR_ILLEGAL_DPIX=(-234)
      integer,PARAMETER :: ERROR_ILLEGAL_ELV=(-235)
      integer,PARAMETER :: ERROR_ILLEGAL_AZM=(-236)
      integer,PARAMETER :: ERROR_ILLEGAL_GRID=(-237)
      integer,PARAMETER :: ERROR_ILLEGAL_MODE=(-238)
      integer,PARAMETER :: ERROR_ACCESSLABEL_UNMATCH=(-239)
      integer,PARAMETER :: ERROR_GRID03D_GEONAME=(-250)
      integer,PARAMETER :: ERROR_GRID03D_ORBITDIR=(-251)
      integer,PARAMETER :: ERROR_GRID03D_PRDCTDATE=(-252)
      integer,PARAMETER :: ERROR_GRID03D_GEOSIZE=(-253)

! Add New return value
      integer,PARAMETER ::  ERROR_CONFIG_ANALYS=(-300)
      integer,PARAMETER ::  ERROR_CONFIG_CMP_TYPE=(-301)
      integer,PARAMETER ::  ERROR_CONFIG_CMP_LVL=(-302)
      integer,PARAMETER ::  ERROR_CONFIG_BYTE_ORDR=(-303)
      integer,PARAMETER ::  ERROR_CONFIG_FILE_KEY=(-304)

      integer,PARAMETER ::  ERROR_NOT_LINE=(-305)
      integer,PARAMETER ::  ERROR_NULL_TABLE=(-306)
      integer,PARAMETER ::  ERROR_INPUT_TIME=(-307)
      integer,PARAMETER ::  ERROR_NOT_DIMS=(-308)
      integer,PARAMETER ::  ERROR_NOT_SIZE=(-309)
      integer,PARAMETER :: ERROR_GET_DS_DIMS=(-310)
      integer,PARAMETER :: ERROR_SET_DATASET=(-311)
      integer,PARAMETER :: ERROR_GET_GROUP_ATTR=(-312)
      integer,PARAMETER :: ERROR_GET_DATASET_ATTR=(-313)
      integer,PARAMETER :: ERROR_SET_GROUP_ATTR=(-314)
      integer,PARAMETER :: ERROR_SET_DATASET_ATTR=(-315)
      integer,PARAMETER :: ERROR_GET_SLOPE=(-316)
      integer,PARAMETER :: ERROR_GET_OFFSET=(-317)
      integer,PARAMETER :: ERROR_GET_SLOPE_REF=(-318)
      integer,PARAMETER :: ERROR_GET_OFFSET_REF=(-319)
      integer,PARAMETER :: ERROR_GET_ERROR_VALUE=(-320)

      integer,PARAMETER :: ERROR_PARAM=(-321)

      integer,PARAMETER :: ERROR_SET_GROUP=(-322)
      integer,PARAMETER :: ERROR_GET_DATASET_NUMERIC_VALUE=(-323)
      integer,PARAMETER :: ERROR_SET_PARENT_GROUP=(-323)

      integer,PARAMETER :: ERROR_NOT_FIND_SLOPE=(-324)
      integer,PARAMETER :: ERROR_NOT_FIND_SLOPE_REF=(-325)
      integer,PARAMETER :: ERROR_NOT_FIND_OFFSET=(-326)
      integer,PARAMETER :: ERROR_NOT_FIND_OFFSET_REF=(-327)

      integer,PARAMETER ::  ERROR_RANGE_DIMS=(-328)

      integer,PARAMETER :: ERROR_NOT_FIND_ERROR=(-329)
      integer,PARAMETER :: ERROR_GET_MIN_ATTR=(-330)
      integer,PARAMETER :: ERROR_NOT_FIND_MIN=(-331)
      integer,PARAMETER :: ERROR_GET_MAX_ATTR=(-332)
      integer,PARAMETER :: ERROR_NOT_FIND_MAX=(-333)
      integer,PARAMETER :: ERROR_GET_BASE_ATTR=(-334)
      integer,PARAMETER :: ERROR_NOT_FIND_BASE=(-335)

      integer,PARAMETER :: ERROR_HDF_FILE_OPEN=(-501)
      integer,PARAMETER :: ERROR_HDF_FILE_CLOSE=(-502)
      integer,PARAMETER :: ERROR_HDF_DIMENSION_SIZE=(-502)
      integer,PARAMETER :: ERROR_DATASET_ACCESSES=(-503)
      integer,PARAMETER :: ERROR_HDF_DATASET_OPEN=(-504)
      integer,PARAMETER :: ERROR_HDF_DATASET_GET_SPACE=(-505)
      integer,PARAMETER :: ERROR_HDF_DATASET_GET_RANK=(-506)
      integer,PARAMETER :: ERROR_HDF_DATASET_GET_DIMS=(-507)
      integer,PARAMETER :: ERROR_HDF_DATASET_CREATE=(-508)
      integer,PARAMETER :: ERROR_HDF_DATASET_WRITE=(-509)
      integer,PARAMETER :: ERROR_HDF_DATASET_READ=(-510)
      integer,PARAMETER :: ERROR_HDF_DATASET_GET_TYPE=(-511)
integer, PARAMETER::ERROR_HDF_ATTR_NAME_OPEN = (-520)
integer, PARAMETER::ERROR_HDF_ATTR_GET_TYPE = (-521)
integer, PARAMETER::ERROR_HDF_ATTR_READ = (-522)
integer, PARAMETER::ERROR_HDF_ATTR_IDX_OPEN = (-523)
integer, PARAMETER::ERROR_HDF_ATTR_CREATE = (-524)
integer, PARAMETER::ERROR_HDF_ATTR_WRITE = (-525)
integer, PARAMETER::ERROR_HDF_DT_GET_CLASS = (-526)
integer, PARAMETER::ERROR_HDF_DT_COPY = (-527)
integer, PARAMETER::ERROR_HDF_DT_SET_SIZE = (-528)
integer, PARAMETER::ERROR_HDF_DT_GET_TYPE = (-529)

integer, PARAMETER::ERROR_HDF_CREATE_SPACE = (-540)
integer, PARAMETER::ERROR_HDF_HYPERSLAB = (-541)

integer, PARAMETER::ERROR_HDF_METAOP_PRDCTNAME = (-550)
integer, PARAMETER::ERROR_HDF_METANG_PRDCTNAME = (-551)
integer, PARAMETER::ERROR_HDF_METAOP_OVERLAP = (-552)
integer, PARAMETER::ERROR_HDF_METANG_OVERLAP = (-553)
integer, PARAMETER::ERROR_HDF_METAOP_GEONAME = (-554)
integer, PARAMETER::ERROR_HDF_METANG_GEONAME = (-555)
integer, PARAMETER::ERROR_HDF_METAOP_GRANULE = (-556)
integer, PARAMETER::ERROR_HDF_METANG_GRANULE = (-557)
integer, PARAMETER::ERROR_HDF_METAOP_COREGA1 = (-558)
integer, PARAMETER::ERROR_HDF_METANG_COREGA1 = (-559)
integer, PARAMETER::ERROR_HDF_METAOP_COREGA2 = (-560)
integer, PARAMETER::ERROR_HDF_METANG_COREGA2 = (-561)
integer, PARAMETER::ERROR_HDF_METAOP_PRJCTION = (-562)
integer, PARAMETER::ERROR_HDF_METANG_PRJCTION = (-563)
integer, PARAMETER::ERROR_HDF_METAOP_ORBITDIR = (-564)
integer, PARAMETER::ERROR_HDF_METANG_ORBITDIR = (-565)
integer, PARAMETER::ERROR_HDF_METAOP_PRDCTDTM = (-566)
integer, PARAMETER::ERROR_HDF_METANG_PRDCTDTM = (-567)

integer, PARAMETER::ERROR_ILLEGAL_DATA_TYPE = (-601)
integer, PARAMETER::ERROR_MINMAX_CHECK = (-602)
integer, PARAMETER::WARNING_DATA = (9999)

!***************************************************************************** /
!*    Function prototypes                                                    * /
!***************************************************************************** /
INTEGER SGTK_open_file
INTEGER SGTK_close_file
INTEGER SGTK_make_group
INTEGER SGTK_utc_to_tai93
INTEGER SGTK_tai93_to_utc
INTEGER SGTK_load_config
INTEGER SGTK_get_global_latlon
INTEGER SGTK_set_dims
INTEGER SGTK_set_dataset_int
INTEGER SGTK_set_dataset_int8
INTEGER SGTK_set_dataset_int16
INTEGER SGTK_set_dataset_int32
INTEGER SGTK_set_dataset_uint
INTEGER SGTK_set_dataset_uint8
INTEGER SGTK_set_dataset_uint16
INTEGER SGTK_set_dataset_uint32
INTEGER SGTK_set_dataset_float
INTEGER SGTK_set_dataset_float32
INTEGER SGTK_set_dataset_float64
INTEGER SGTK_set_dataset_latlon
INTEGER SGTK_set_meta_string
INTEGER SGTK_set_meta_int
INTEGER SGTK_set_meta_int8
INTEGER SGTK_set_meta_int16
INTEGER SGTK_set_meta_int32
INTEGER SGTK_set_meta_uint
INTEGER SGTK_set_meta_uint8
INTEGER SGTK_set_meta_uint16
INTEGER SGTK_set_meta_uint32
INTEGER SGTK_set_meta_float
INTEGER SGTK_set_meta_float32
INTEGER SGTK_set_meta_float64
INTEGER SGTK_get_dims
INTEGER SGTK_get_dataset_int
INTEGER SGTK_get_dataset_int8
INTEGER SGTK_get_dataset_int16
INTEGER SGTK_get_dataset_int32
INTEGER SGTK_get_dataset_uint
INTEGER SGTK_get_dataset_uint8
INTEGER SGTK_get_dataset_uint16
INTEGER SGTK_get_dataset_uint32
INTEGER SGTK_get_dataset_float
INTEGER SGTK_get_dataset_float32
INTEGER SGTK_get_dataset_float64
INTEGER SGTK_get_dataset_latlon
INTEGER SGTK_get_meta_string
INTEGER SGTK_get_meta_int
INTEGER SGTK_get_meta_int8
INTEGER SGTK_get_meta_int16
INTEGER SGTK_get_meta_int32
INTEGER SGTK_get_meta_uint
INTEGER SGTK_get_meta_uint8
INTEGER SGTK_get_meta_uint16
INTEGER SGTK_get_meta_uint32
INTEGER SGTK_get_meta_float
INTEGER SGTK_get_meta_float32
INTEGER SGTK_get_meta_float64
INTEGER SGTK_make_parameter_table



	  