C*****************************************************************************/
C*  Copyright (C) NEC Corporation 2015 All rights reserved.                  */
C*  File Name    : SGTK_f.h                                                  */
C*  Abstract     : I/O toolkit header file for fortran                       */
C*                                                                           */
C*  Author     NEC                                                           */
C*  Date       2015/03/20                                                    */
C*  Version    1.00                                                          */
C*  Notice                                                                   */
C*****************************************************************************/


C*****************************************************************************/
C* data type define                                                          */
C*****************************************************************************/
      Integer SGTK_H5T_STD_I8_TYPE
      PARAMETER(SGTK_H5T_STD_I8_TYPE=0)
      Integer SGTK_H5T_STD_U8_TYPE
      PARAMETER(SGTK_H5T_STD_U8_TYPE=1)
      Integer SGTK_H5T_STD_I16_TYPE
      PARAMETER(SGTK_H5T_STD_I16_TYPE=2)
      Integer SGTK_H5T_STD_U16_TYPE
      PARAMETER(SGTK_H5T_STD_U16_TYPE=3)
      Integer SGTK_H5T_STD_I32_TYPE
      PARAMETER(SGTK_H5T_STD_I32_TYPE=4)
      Integer SGTK_H5T_STD_U32_TYPE
      PARAMETER(SGTK_H5T_STD_U32_TYPE=5)
      Integer SGTK_H5T_STD_I64_TYPE
      PARAMETER(SGTK_H5T_STD_I64_TYPE=6)
      Integer SGTK_H5T_STD_U64_TYPE
      PARAMETER(SGTK_H5T_STD_U64_TYPE=7)
      Integer SGTK_H5T_IEEE_F32_TYPE
      PARAMETER(SGTK_H5T_IEEE_F32_TYPE=8)
      Integer SGTK_H5T_IEEE_F64_TYPE
      PARAMETER(SGTK_H5T_IEEE_F64_TYPE=9)
      Integer SGTK_H5T_C_S1_TYPE
      PARAMETER(SGTK_H5T_C_S1_TYPE=10)

C*****************************************************************************/
C* kind of value (radiance/reflectance/other).                               */
C*****************************************************************************/
      integer SGTK_KIND_RADIANCE
      integer SGTK_KIND_REFLECTANCE
      integer SGTK_KIND_OTHER
      PARAMETER(SGTK_KIND_RADIANCE=0)
      PARAMETER(SGTK_KIND_REFLECTANCE=1)
      PARAMETER(SGTK_KIND_OTHER=3)

C*****************************************************************************/
C* file open mode.                                                           */
C*****************************************************************************/
      integer IOTK_ON,IOTK_OFF
      PARAMETER(IOTK_ON=1)
      PARAMETER(IOTK_OFF=0)

      integer SUCCESS,FAIL,ERROR_FILE_OPEN,ERROR_MALLOC
      integer ERROR_ENV_NAME,ERROR_LEAP_SEC,ERROR_DIR_OPEN
      integer ERROR_FILE_READ,ERROR_FILE_CLOS,ERROR_FILE_SEQ
      integer ERROR_FILE_SIZE,ERROR_GEOPHSICAL_FILE
      PARAMETER(SUCCESS=0)
      PARAMETER(FAIL=(-1))
      PARAMETER(ERROR_FILE_OPEN=(-100))
      PARAMETER(ERROR_MALLOC=(-101))
      PARAMETER(ERROR_ENV_NAME=(-102))
      PARAMETER(ERROR_LEAP_SEC=(-103))
      PARAMETER(ERROR_DIR_OPEN=(-104))
      PARAMETER(ERROR_FILE_READ=(-105))
      PARAMETER(ERROR_FILE_CLOS=(-106))
      PARAMETER(ERROR_FILE_SEQ=(-107))
      PARAMETER(ERROR_FILE_SIZE=(-108))
      PARAMETER(ERROR_GEOPHSICAL_FILE=(-109))

      integer ERROR_ILLEGAL_YEAR,ERROR_ILLEGAL_MONTH
      integer ERROR_ILLEGAL_DAY,ERROR_ILLEGAL_HOUR
      integer ERROR_ILLEGAL_MIN,ERROR_ILLEGAL_SEC
      integer ERROR_ILLEGAL_MS,ERROR_ILLEGAL_DATE
      integer ERROR_ILLEGAL_TOTALSEC,ERROR_ILLEGAL_FILENAME
      integer ERROR_ILLEGAL_SCANNUM_S,ERROR_ILLEGAL_SCANNUM_E
      integer ERROR_ILLEGAL_HDF_FILEID,ERROR_ILLEGAL_INDEX
      integer ERROR_ILLEGAL_DIMS,ERROR_NOT_WRITEDATA
      integer ERROR_NOT_ACCESSLABEL,ERROR_ACCESSLABEL_WRITE_NG
      integer ERROR_ACCESSLABEL_READ_NG,ERROR_MEMSIZE
      integer ERROR_NULL_ADDRESS,ERROR_ILLEGAL_METADATA
      integer ERROR_ILLEGAL_TFLG,ERROR_ILLEGAL_PRMG
      integer ERROR_ILLEGAL_PRMA,ERROR_ILLEGAL_LEV
      integer ERROR_ILLEGAL_LAT,ERROR_ILLEGAL_LON
      integer ERROR_ILLEGAL_IFLG,ERROR_NOT_TARGET_FILE
      integer ERROR_ILLEGAL_SECTIONNO,ERROR_ILLEGAL_NPIX
      integer ERROR_ILLEGAL_HEIGHT,ERROR_ILLEGAL_DPIX
      integer ERROR_ILLEGAL_ELV,ERROR_ILLEGAL_AZM
      integer ERROR_ILLEGAL_GRID,ERROR_ILLEGAL_MODE
      integer ERROR_ACCESSLABEL_UNMATCH,ERROR_GRID03D_GEONAME
      integer ERROR_GRID03D_ORBITDIR,ERROR_GRID03D_PRDCTDATE
      integer ERROR_GRID03D_GEOSIZE

      PARAMETER(ERROR_ILLEGAL_YEAR=(-201))
      PARAMETER(ERROR_ILLEGAL_MONTH=(-202))
      PARAMETER(ERROR_ILLEGAL_DAY=(-203))
      PARAMETER(ERROR_ILLEGAL_HOUR=(-204))
      PARAMETER(ERROR_ILLEGAL_MIN=(-205))
      PARAMETER(ERROR_ILLEGAL_SEC=(-206))
      PARAMETER(ERROR_ILLEGAL_MS=(-207))
      PARAMETER(ERROR_ILLEGAL_DATE=(-208))
      PARAMETER(ERROR_ILLEGAL_TOTALSEC=(-209))
      PARAMETER(ERROR_ILLEGAL_FILENAME=(-210))
      PARAMETER(ERROR_ILLEGAL_SCANNUM_S=(-211))
      PARAMETER(ERROR_ILLEGAL_SCANNUM_E=(-212))
      PARAMETER(ERROR_ILLEGAL_HDF_FILEID=(-213))
      PARAMETER(ERROR_ILLEGAL_INDEX=(-214))
      PARAMETER(ERROR_ILLEGAL_DIMS=(-215))
      PARAMETER(ERROR_NOT_WRITEDATA=(-216))
      PARAMETER(ERROR_NOT_ACCESSLABEL=(-217))
      PARAMETER(ERROR_ACCESSLABEL_WRITE_NG=(-218))
      PARAMETER(ERROR_ACCESSLABEL_READ_NG=(-219))
      PARAMETER(ERROR_MEMSIZE=(-220))
      PARAMETER(ERROR_NULL_ADDRESS=(-221))
      PARAMETER(ERROR_ILLEGAL_METADATA=(-222))
      PARAMETER(ERROR_ILLEGAL_TFLG=(-223))
      PARAMETER(ERROR_ILLEGAL_PRMG=(-224))
      PARAMETER(ERROR_ILLEGAL_PRMA=(-225))
      PARAMETER(ERROR_ILLEGAL_LEV=(-226))
      PARAMETER(ERROR_ILLEGAL_LAT=(-227))
      PARAMETER(ERROR_ILLEGAL_LON=(-228))
      PARAMETER(ERROR_ILLEGAL_IFLG=(-229))
      PARAMETER(ERROR_NOT_TARGET_FILE=(-230))
      PARAMETER(ERROR_ILLEGAL_SECTIONNO=(-231))
      PARAMETER(ERROR_ILLEGAL_NPIX=(-232))
      PARAMETER(ERROR_ILLEGAL_HEIGHT=(-233))
      PARAMETER(ERROR_ILLEGAL_DPIX=(-234))
      PARAMETER(ERROR_ILLEGAL_ELV=(-235))
      PARAMETER(ERROR_ILLEGAL_AZM=(-236))
      PARAMETER(ERROR_ILLEGAL_GRID=(-237))
      PARAMETER(ERROR_ILLEGAL_MODE=(-238))
      PARAMETER(ERROR_ACCESSLABEL_UNMATCH=(-239))
      PARAMETER(ERROR_GRID03D_GEONAME=(-250))
      PARAMETER(ERROR_GRID03D_ORBITDIR=(-251))
      PARAMETER(ERROR_GRID03D_PRDCTDATE=(-252))
      PARAMETER(ERROR_GRID03D_GEOSIZE=(-253))

! Add New return value
      integer ERROR_CONFIG_ANALYS,ERROR_CONFIG_CMP_TYPE
      integer ERROR_CONFIG_CMP_LVL,ERROR_CONFIG_BYTE_ORDR
      integer ERROR_CONFIG_FILE_KEY
      PARAMETER(ERROR_CONFIG_ANALYS=(-300))
      PARAMETER(ERROR_CONFIG_CMP_TYPE=(-301))
      PARAMETER(ERROR_CONFIG_CMP_LVL=(-302))
      PARAMETER(ERROR_CONFIG_BYTE_ORDR=(-303))
      PARAMETER(ERROR_CONFIG_FILE_KEY=(-304))

      integer ERROR_NOT_LINE,ERROR_NULL_TABLE
      integer ERROR_INPUT_TIME,ERROR_NOT_DIMS
      integer ERROR_NOT_SIZE,ERROR_GET_DS_DIMS
      integer ERROR_SET_DATASET,ERROR_GET_GROUP_ATTR
      integer ERROR_GET_DATASET_ATTR,ERROR_SET_GROUP_ATTR
      integer ERROR_SET_DATASET_ATTR,ERROR_GET_SLOPE
      integer ERROR_GET_OFFSET,ERROR_GET_SLOPE_REF
      integer ERROR_GET_OFFSET_REF,ERROR_GET_ERROR_VALUE
      PARAMETER(ERROR_NOT_LINE=(-305))
      PARAMETER(ERROR_NULL_TABLE=(-306))
      PARAMETER(ERROR_INPUT_TIME=(-307))
      PARAMETER(ERROR_NOT_DIMS=(-308))
      PARAMETER(ERROR_NOT_SIZE=(-309))
      PARAMETER(ERROR_GET_DS_DIMS=(-310))
      PARAMETER(ERROR_SET_DATASET=(-311))
      PARAMETER(ERROR_GET_GROUP_ATTR=(-312))
      PARAMETER(ERROR_GET_DATASET_ATTR=(-313))
      PARAMETER(ERROR_SET_GROUP_ATTR=(-314))
      PARAMETER(ERROR_SET_DATASET_ATTR=(-315))
      PARAMETER(ERROR_GET_SLOPE=(-316))
      PARAMETER(ERROR_GET_OFFSET=(-317))
      PARAMETER(ERROR_GET_SLOPE_REF=(-318))
      PARAMETER(ERROR_GET_OFFSET_REF=(-319))
      PARAMETER(ERROR_GET_ERROR_VALUE=(-320))

      integer ERROR_PARAM
      PARAMETER(ERROR_PARAM=(-321))

      integer ERROR_SET_GROUP,ERROR_GET_DATASET_NUMERIC_VALUE
      integer ERROR_SET_PARENT_GROUP
      PARAMETER(ERROR_SET_GROUP=(-322))
      PARAMETER(ERROR_GET_DATASET_NUMERIC_VALUE=(-323))
      PARAMETER(ERROR_SET_PARENT_GROUP=(-323))

      integer ERROR_NOT_FIND_SLOPE,ERROR_NOT_FIND_SLOPE_REF
      integer ERROR_NOT_FIND_OFFSET,ERROR_NOT_FIND_OFFSET_REF
      PARAMETER(ERROR_NOT_FIND_SLOPE=(-324))
      PARAMETER(ERROR_NOT_FIND_SLOPE_REF=(-325))
      PARAMETER(ERROR_NOT_FIND_OFFSET=(-326))
      PARAMETER(ERROR_NOT_FIND_OFFSET_REF=(-327))

      integer ERROR_RANGE_DIMS
      PARAMETER(ERROR_RANGE_DIMS=(-328))

      integer ERROR_NOT_FIND_ERROR,ERROR_GET_MIN_ATTR
      integer ERROR_NOT_FIND_MIN,ERROR_GET_MAX_ATTR
      integer ERROR_NOT_FIND_MAX,ERROR_GET_BASE_ATTR
      integer ERROR_NOT_FIND_BASE
      PARAMETER(ERROR_NOT_FIND_ERROR=(-329))
      PARAMETER(ERROR_GET_MIN_ATTR=(-330))
      PARAMETER(ERROR_NOT_FIND_MIN=(-331))
      PARAMETER(ERROR_GET_MAX_ATTR=(-332))
      PARAMETER(ERROR_NOT_FIND_MAX=(-333))
      PARAMETER(ERROR_GET_BASE_ATTR=(-334))
      PARAMETER(ERROR_NOT_FIND_BASE=(-335))

      integer ERROR_HDF_FILE_OPEN,ERROR_HDF_FILE_CLOSE
      integer ERROR_HDF_DIMENSION_SIZE,ERROR_DATASET_ACCESSES
      integer ERROR_HDF_DATASET_OPEN,ERROR_HDF_DATASET_GET_SPACE
      integer ERROR_HDF_DATASET_GET_RANK,ERROR_HDF_DATASET_GET_DIMS
      integer ERROR_HDF_DATASET_CREATE,ERROR_HDF_DATASET_WRITE
      integer ERROR_HDF_DATASET_READ,ERROR_HDF_DATASET_GET_TYPE
      integer ERROR_HDF_ATTR_NAME_OPEN,ERROR_HDF_ATTR_GET_TYPE
      integer ERROR_HDF_ATTR_READ,ERROR_HDF_ATTR_IDX_OPEN
      integer ERROR_HDF_ATTR_CREATE,ERROR_HDF_ATTR_WRITE
      integer ERROR_HDF_DT_GET_CLASS,ERROR_HDF_DT_COPY
      integer ERROR_HDF_DT_SET_SIZE,ERROR_HDF_DT_GET_TYPE
      PARAMETER(ERROR_HDF_FILE_OPEN=(-501))
      PARAMETER(ERROR_HDF_FILE_CLOSE=(-502))
      PARAMETER(ERROR_HDF_DIMENSION_SIZE=(-502))
      PARAMETER(ERROR_DATASET_ACCESSES=(-503))
      PARAMETER(ERROR_HDF_DATASET_OPEN=(-504))
      PARAMETER(ERROR_HDF_DATASET_GET_SPACE=(-505))
      PARAMETER(ERROR_HDF_DATASET_GET_RANK=(-506))
      PARAMETER(ERROR_HDF_DATASET_GET_DIMS=(-507))
      PARAMETER(ERROR_HDF_DATASET_CREATE=(-508))
      PARAMETER(ERROR_HDF_DATASET_WRITE=(-509))
      PARAMETER(ERROR_HDF_DATASET_READ=(-510))
      PARAMETER(ERROR_HDF_DATASET_GET_TYPE=(-511))
      PARAMETER(ERROR_HDF_ATTR_NAME_OPEN=(-520))
      PARAMETER(ERROR_HDF_ATTR_GET_TYPE=(-521))
      PARAMETER(ERROR_HDF_ATTR_READ=(-522))
      PARAMETER(ERROR_HDF_ATTR_IDX_OPEN=(-523))
      PARAMETER(ERROR_HDF_ATTR_CREATE=(-524))
      PARAMETER(ERROR_HDF_ATTR_WRITE=(-525))
      PARAMETER(ERROR_HDF_DT_GET_CLASS=(-526))
      PARAMETER(ERROR_HDF_DT_COPY=(-527))
      PARAMETER(ERROR_HDF_DT_SET_SIZE=(-528))
      PARAMETER(ERROR_HDF_DT_GET_TYPE=(-529))

      integer ERROR_HDF_CREATE_SPACE,ERROR_HDF_HYPERSLAB
      PARAMETER(ERROR_HDF_CREATE_SPACE=(-540))
      PARAMETER(ERROR_HDF_HYPERSLAB=(-541))

      integer ERROR_HDF_METAOP_PRDCTNAME,ERROR_HDF_METANG_PRDCTNAME
      integer ERROR_HDF_METAOP_OVERLAP,ERROR_HDF_METANG_OVERLAP
      integer ERROR_HDF_METAOP_GEONAME,ERROR_HDF_METANG_GEONAME
      integer ERROR_HDF_METAOP_GRANULE,ERROR_HDF_METANG_GRANULE
      integer ERROR_HDF_METAOP_COREGA1,ERROR_HDF_METANG_COREGA1
      integer ERROR_HDF_METAOP_COREGA2,ERROR_HDF_METANG_COREGA2
      integer ERROR_HDF_METAOP_PRJCTION,ERROR_HDF_METANG_PRJCTION
      integer ERROR_HDF_METAOP_ORBITDIR,ERROR_HDF_METANG_ORBITDIR
      integer ERROR_HDF_METAOP_PRDCTDTM,ERROR_HDF_METANG_PRDCTDTM
      PARAMETER(ERROR_HDF_METAOP_PRDCTNAME=(-550))
      PARAMETER(ERROR_HDF_METANG_PRDCTNAME=(-551))
      PARAMETER(ERROR_HDF_METAOP_OVERLAP=(-552))
      PARAMETER(ERROR_HDF_METANG_OVERLAP=(-553))
      PARAMETER(ERROR_HDF_METAOP_GEONAME=(-554))
      PARAMETER(ERROR_HDF_METANG_GEONAME=(-555))
      PARAMETER(ERROR_HDF_METAOP_GRANULE=(-556))
      PARAMETER(ERROR_HDF_METANG_GRANULE=(-557))
      PARAMETER(ERROR_HDF_METAOP_COREGA1=(-558))
      PARAMETER(ERROR_HDF_METANG_COREGA1=(-559))
      PARAMETER(ERROR_HDF_METAOP_COREGA2=(-560))
      PARAMETER(ERROR_HDF_METANG_COREGA2=(-561))
      PARAMETER(ERROR_HDF_METAOP_PRJCTION=(-562))
      PARAMETER(ERROR_HDF_METANG_PRJCTION=(-563))
      PARAMETER(ERROR_HDF_METAOP_ORBITDIR=(-564))
      PARAMETER(ERROR_HDF_METANG_ORBITDIR=(-565))
      PARAMETER(ERROR_HDF_METAOP_PRDCTDTM=(-566))
      PARAMETER(ERROR_HDF_METANG_PRDCTDTM=(-567))

      integer ERROR_ILLEGAL_DATA_TYPE,ERROR_MINMAX_CHECK,WARNING_DATA
      PARAMETER(ERROR_ILLEGAL_DATA_TYPE=(-601))
      PARAMETER(ERROR_MINMAX_CHECK=(-602))
      PARAMETER(WARNING_DATA=(9999))

C*****************************************************************************/
C*    Function prototypes                                                    */
C*****************************************************************************/
      INTEGER SGTK_open_file
      INTEGER SGTK_close_file
      INTEGER SGTK_make_group
      INTEGER SGTK_utc_to_tai93
      INTEGER SGTK_tai93_to_utc
      INTEGER SGTK_load_config
      INTEGER SGTK_get_global_latlon
      INTEGER SGTK_set_dims
      INTEGER SGTK_set_dataset_int
      INTEGER SGTK_set_dataset_int8
      INTEGER SGTK_set_dataset_int16
      INTEGER SGTK_set_dataset_int32
      INTEGER SGTK_set_dataset_uint
      INTEGER SGTK_set_dataset_uint8
      INTEGER SGTK_set_dataset_uint16
      INTEGER SGTK_set_dataset_uint32
      INTEGER SGTK_set_dataset_float
      INTEGER SGTK_set_dataset_float32
      INTEGER SGTK_set_dataset_float64
      INTEGER SGTK_set_dataset_latlon
      INTEGER SGTK_set_meta_string
      INTEGER SGTK_set_meta_int
      INTEGER SGTK_set_meta_int8
      INTEGER SGTK_set_meta_int16
      INTEGER SGTK_set_meta_int32
      INTEGER SGTK_set_meta_uint
      INTEGER SGTK_set_meta_uint8
      INTEGER SGTK_set_meta_uint16
      INTEGER SGTK_set_meta_uint32
      INTEGER SGTK_set_meta_float
      INTEGER SGTK_set_meta_float32
      INTEGER SGTK_set_meta_float64
      INTEGER SGTK_get_dims
      INTEGER SGTK_get_dataset_int
      INTEGER SGTK_get_dataset_int8
      INTEGER SGTK_get_dataset_int16
      INTEGER SGTK_get_dataset_int32
      INTEGER SGTK_get_dataset_uint
      INTEGER SGTK_get_dataset_uint8
      INTEGER SGTK_get_dataset_uint16
      INTEGER SGTK_get_dataset_uint32
      INTEGER SGTK_get_dataset_float
      INTEGER SGTK_get_dataset_float32
      INTEGER SGTK_get_dataset_float64
      INTEGER SGTK_get_dataset_latlon
      INTEGER SGTK_get_meta_string
      INTEGER SGTK_get_meta_int
      INTEGER SGTK_get_meta_int8
      INTEGER SGTK_get_meta_int16
      INTEGER SGTK_get_meta_int32
      INTEGER SGTK_get_meta_uint
      INTEGER SGTK_get_meta_uint8
      INTEGER SGTK_get_meta_uint16
      INTEGER SGTK_get_meta_uint32
      INTEGER SGTK_get_meta_float
      INTEGER SGTK_get_meta_float32
      INTEGER SGTK_get_meta_float64

