/*****************************************************************************/
/*  Copyright (C) NEC Corporation 2015 All rights reserved.                  */
/*  File Name    : SGTK_ret_value.h                                          */
/*  Abstract     : I/O toolkit header file                                   */
/*                                                                           */
/*  Author     NEC                                                           */
/*  Date       2015/03/20                                                    */
/*  Version    1.00                                                          */
/*  Notice                                                                   */
/*****************************************************************************/
#ifndef SGTK_RET_VALUE_H
#define SGTK_RET_VALUE_H

#ifdef __LINUX__
#include <byteswap.h>
#endif

#define IOTK_ON     1
#define IOTK_OFF    0

#define SUCCESS                     (0)
#define FAIL                        (-1)
#define ERROR_FILE_OPEN             (-100)
#define ERROR_MALLOC                (-101)
#define ERROR_ENV_NAME              (-102)
#define ERROR_LEAP_SEC              (-103)
#define ERROR_DIR_OPEN              (-104)
#define ERROR_FILE_READ             (-105)
#define ERROR_FILE_CLOS             (-106)
#define ERROR_FILE_SEQ              (-107)
#define ERROR_FILE_SIZE             (-108)
#define ERROR_GEOPHSICAL_FILE       (-109)

#define ERROR_ILLEGAL_YEAR          (-201)
#define ERROR_ILLEGAL_MONTH         (-202)
#define ERROR_ILLEGAL_DAY           (-203)
#define ERROR_ILLEGAL_HOUR          (-204)
#define ERROR_ILLEGAL_MIN           (-205)
#define ERROR_ILLEGAL_SEC           (-206)
#define ERROR_ILLEGAL_MS            (-207)
#define ERROR_ILLEGAL_DATE          (-208)
#define ERROR_ILLEGAL_TOTALSEC      (-209)
#define ERROR_ILLEGAL_FILENAME      (-210)
#define ERROR_ILLEGAL_SCANNUM_S     (-211)
#define ERROR_ILLEGAL_SCANNUM_E     (-212)
#define ERROR_ILLEGAL_HDF_FILEID    (-213)
#define ERROR_ILLEGAL_INDEX         (-214)
#define ERROR_ILLEGAL_DIMS          (-215)
#define ERROR_NOT_WRITEDATA         (-216)
#define ERROR_NOT_ACCESSLABEL       (-217)
#define ERROR_ACCESSLABEL_WRITE_NG  (-218)
#define ERROR_ACCESSLABEL_READ_NG   (-219)
#define ERROR_MEMSIZE               (-220)
#define ERROR_NULL_ADDRESS          (-221)
#define ERROR_ILLEGAL_METADATA      (-222)
#define ERROR_ILLEGAL_TFLG          (-223)
#define ERROR_ILLEGAL_PRMG          (-224)
#define ERROR_ILLEGAL_PRMA          (-225)
#define ERROR_ILLEGAL_LEV           (-226)
#define ERROR_ILLEGAL_LAT           (-227)
#define ERROR_ILLEGAL_LON           (-228)
#define ERROR_ILLEGAL_IFLG          (-229)
#define ERROR_NOT_TARGET_FILE       (-230)
#define ERROR_ILLEGAL_SECTIONNO     (-231)
#define ERROR_ILLEGAL_NPIX          (-232)
#define ERROR_ILLEGAL_HEIGHT        (-233)
#define ERROR_ILLEGAL_DPIX          (-234)
#define ERROR_ILLEGAL_ELV           (-235)
#define ERROR_ILLEGAL_AZM           (-236)
#define ERROR_ILLEGAL_GRID          (-237)
#define ERROR_ILLEGAL_MODE          (-238)
#define ERROR_ACCESSLABEL_UNMATCH   (-239)
#define ERROR_GRID03D_GEONAME       (-250)
#define ERROR_GRID03D_ORBITDIR      (-251)
#define ERROR_GRID03D_PRDCTDATE     (-252)
#define ERROR_GRID03D_GEOSIZE       (-253)

// Add New return value
#define ERROR_CONFIG_ANALYS         (-300)
#define ERROR_CONFIG_CMP_TYPE       (-301)
#define ERROR_CONFIG_CMP_LVL        (-302)
#define ERROR_CONFIG_BYTE_ORDR      (-303)
#define ERROR_CONFIG_FILE_KEY       (-304)

#define ERROR_NOT_LINE              (-305)
#define ERROR_NULL_TABLE            (-306)
#define ERROR_INPUT_TIME            (-307)
#define ERROR_NOT_DIMS              (-308)
#define ERROR_NOT_SIZE              (-309)
#define ERROR_GET_DS_DIMS           (-310)
#define ERROR_SET_DATASET           (-311)
#define ERROR_GET_GROUP_ATTR        (-312)
#define ERROR_GET_DATASET_ATTR      (-313)
#define ERROR_SET_GROUP_ATTR        (-314)
#define ERROR_SET_DATASET_ATTR      (-315)
#define ERROR_GET_SLOPE             (-316)
#define ERROR_GET_OFFSET            (-317)
#define ERROR_GET_SLOPE_REF         (-318)
#define ERROR_GET_OFFSET_REF        (-319)
#define ERROR_GET_ERROR_VALUE       (-320)

#define ERROR_PARAM                 (-321)

#define ERROR_SET_GROUP                 (-322)
#define ERROR_GET_DATASET_NUMERIC_VALUE (-323)
#define ERROR_SET_PARENT_GROUP          (-323)

#define ERROR_NOT_FIND_SLOPE        (-324)
#define ERROR_NOT_FIND_SLOPE_REF    (-325)
#define ERROR_NOT_FIND_OFFSET       (-326)
#define ERROR_NOT_FIND_OFFSET_REF   (-327)

#define ERROR_RANGE_DIMS            (-328)

#define ERROR_NOT_FIND_ERROR        (-329)
#define ERROR_GET_MIN_ATTR          (-330)
#define ERROR_NOT_FIND_MIN          (-331)
#define ERROR_GET_MAX_ATTR          (-332)
#define ERROR_NOT_FIND_MAX          (-333)
#define ERROR_GET_BASE_ATTR         (-334)
#define ERROR_NOT_FIND_BASE         (-335)

#define ERROR_HDF_FILE_OPEN         (-501)
#define ERROR_HDF_FILE_CLOSE        (-502)
#define ERROR_HDF_DIMENSION_SIZE    (-502)
#define ERROR_DATASET_ACCESSES      (-503)
#define ERROR_HDF_DATASET_OPEN      (-504)
#define ERROR_HDF_DATASET_GET_SPACE (-505)
#define ERROR_HDF_DATASET_GET_RANK  (-506)
#define ERROR_HDF_DATASET_GET_DIMS  (-507)
#define ERROR_HDF_DATASET_CREATE    (-508)
#define ERROR_HDF_DATASET_WRITE     (-509)
#define ERROR_HDF_DATASET_READ      (-510)
#define ERROR_HDF_DATASET_GET_TYPE  (-511)
#define ERROR_HDF_ATTR_NAME_OPEN    (-520)
#define ERROR_HDF_ATTR_GET_TYPE     (-521)
#define ERROR_HDF_ATTR_READ         (-522)
#define ERROR_HDF_ATTR_IDX_OPEN     (-523)
#define ERROR_HDF_ATTR_CREATE       (-524)
#define ERROR_HDF_ATTR_WRITE        (-525)
#define ERROR_HDF_DT_GET_CLASS      (-526)
#define ERROR_HDF_DT_COPY           (-527)
#define ERROR_HDF_DT_SET_SIZE       (-528)
#define ERROR_HDF_DT_GET_TYPE       (-529)

#define ERROR_HDF_CREATE_SPACE      (-540)
#define ERROR_HDF_HYPERSLAB         (-541)

#define ERROR_HDF_METAOP_PRDCTNAME  (-550)
#define ERROR_HDF_METANG_PRDCTNAME  (-551)
#define ERROR_HDF_METAOP_OVERLAP    (-552)
#define ERROR_HDF_METANG_OVERLAP    (-553)
#define ERROR_HDF_METAOP_GEONAME    (-554)
#define ERROR_HDF_METANG_GEONAME    (-555)
#define ERROR_HDF_METAOP_GRANULE    (-556)
#define ERROR_HDF_METANG_GRANULE    (-557)
#define ERROR_HDF_METAOP_COREGA1    (-558)
#define ERROR_HDF_METANG_COREGA1    (-559)
#define ERROR_HDF_METAOP_COREGA2    (-560)
#define ERROR_HDF_METANG_COREGA2    (-561)
#define ERROR_HDF_METAOP_PRJCTION   (-562)
#define ERROR_HDF_METANG_PRJCTION   (-563)
#define ERROR_HDF_METAOP_ORBITDIR   (-564)
#define ERROR_HDF_METANG_ORBITDIR   (-565)
#define ERROR_HDF_METAOP_PRDCTDTM   (-566)
#define ERROR_HDF_METANG_PRDCTDTM   (-567)

#define ERROR_ILLEGAL_DATA_TYPE     (-601)
#define ERROR_MINMAX_CHECK          (-602)
#define WARNING_DATA                (9999)

#endif
