#ifndef _SGTK_F9X_H_
#define _SGTK_F9X_H_

#include <stdint.h>
#include <hdf5.h>

typedef unsigned int uint;

/*****************************************************************************/
/* ".CPP"   Function prototypes                                              */
/*****************************************************************************/
extern hid_t SGTK_open_file(char *file_name);
extern int SGTK_close_file(hid_t HDF_file_id);
extern int SGTK_get_dims(hid_t HDF_file_id, char *label, int **num);
extern int SGTK_get_dataset_int(hid_t HDF_file_id, char *label, int **get_value);
extern int SGTK_get_dataset_int8(hid_t HDF_file_id, char *label, int8_t **get_value);
extern int SGTK_get_dataset_int16(hid_t HDF_file_id, char *label, int16_t **get_value);
extern int SGTK_get_dataset_int32(hid_t HDF_file_id, char *label, int32_t **get_value);
extern int SGTK_get_dataset_uint(hid_t HDF_file_id, char *label, uint **get_value);
extern int SGTK_get_dataset_uint8(hid_t HDF_file_id, char *label, uint8_t **get_value);
extern int SGTK_get_dataset_uint16(hid_t HDF_file_id, char *label, uint16_t **get_value);
extern int SGTK_get_dataset_uint32(hid_t HDF_file_id, char *label, uint32_t **get_value);
extern int SGTK_get_dataset_float(hid_t HDF_file_id, char *label, int kind, float **get_value);
extern int SGTK_get_dataset_float32(hid_t HDF_file_id, char *label, int kind, float **get_value);
extern int SGTK_get_dataset_float64(hid_t HDF_file_id, char *label, int kind, double **get_value);
extern int SGTK_get_dataset_latlon(hid_t HDF_file_id, char *latitude_access_label, char *longitude_access_label, int kind, int start_no, int end_no, float **latlong_buffer_address);

extern int SGTK_set_dims(hid_t HDF_file_id, char *label, int *dims, int rank, int dat_type, char **dim_lbl);

extern int SGTK_set_dataset_int(hid_t HDF_file_id, char *label, int *dims, int rank, int *value);
extern int SGTK_set_dataset_int8(hid_t HDF_file_id, char *label, int *dims, int rank, int8_t *value);
extern int SGTK_set_dataset_int16(hid_t HDF_file_id, char *label, int *dims, int rank, int16_t *value);
extern int SGTK_set_dataset_int32(hid_t HDF_file_id, char *label, int *dims, int rank, int32_t *value);
extern int SGTK_set_dataset_uint(hid_t HDF_file_id, char *label, int *dims, int rank, uint *value);
extern int SGTK_set_dataset_uint8(hid_t HDF_file_id, char *label, int *dims, int rank, uint8_t *value);
extern int SGTK_set_dataset_uint16(hid_t HDF_file_id, char *label, int *dims, int rank, uint16_t *value);
extern int SGTK_set_dataset_uint32(hid_t HDF_file_id, char *label, int *dims, int rank, uint32_t *value);

extern int SGTK_set_dataset_float(hid_t HDF_file_id, char *label, int mode, int *dims, int rank, float *value);
extern int SGTK_set_dataset_float32(hid_t HDF_file_id, char *label, int mode, int *dims, int rank, float *value);
extern int SGTK_set_dataset_float64(hid_t HDF_file_id, char *label, int mode, int *dims, int rank, double *value);
extern int SGTK_set_dataset_latlon(hid_t HDF_file_id, char *label_lat, char *label_lon, int kind, int start_no, int end_no, int set_num, float *latlon);

extern int SGTK_get_meta_string(hid_t HDF_file_id, char *label, char *meta, char *value);
extern int SGTK_get_meta_int(hid_t HDF_file_id, char *label, char *meta, int *value);
extern int SGTK_get_meta_int8(hid_t HDF_file_id, char *label, char *meta, int8_t *value);
extern int SGTK_get_meta_int16(hid_t HDF_file_id, char *label, char *meta, int16_t *value);
extern int SGTK_get_meta_int32(hid_t HDF_file_id, char *label, char *meta, int32_t *value);
extern int SGTK_get_meta_uint(hid_t HDF_file_id, char *label, char *meta, uint *value);
extern int SGTK_get_meta_uint8(hid_t HDF_file_id, char *label, char *meta, uint8_t *value);
extern int SGTK_get_meta_uint16(hid_t HDF_file_id, char *label, char *meta, uint16_t *value);
extern int SGTK_get_meta_uint32(hid_t HDF_file_id, char *label, char *meta, uint32_t *value);
extern int SGTK_get_meta_float(hid_t HDF_file_id, char *label, char *meta, float *value);
extern int SGTK_get_meta_float32(hid_t HDF_file_id, char *label, char *meta, float *value);
extern int SGTK_get_meta_float64(hid_t HDF_file_id, char *label, char *meta, double *value);

extern int SGTK_set_meta_string(hid_t HDF_file_id, char *label, char *meta, char *value);
extern int SGTK_set_meta_int(hid_t HDF_file_id, char *label, char *meta, int value);
extern int SGTK_set_meta_int8(hid_t HDF_file_id, char *label, char *meta, int8_t value);
extern int SGTK_set_meta_int16(hid_t HDF_file_id, char *label, char *meta, int16_t value);
extern int SGTK_set_meta_int32(hid_t HDF_file_id, char *label, char *meta, int32_t value);
extern int SGTK_set_meta_uint(hid_t HDF_file_id, char *label, char *meta, uint value);
extern int SGTK_set_meta_uint8(hid_t HDF_file_id, char *label, char *meta, uint8_t value);
extern int SGTK_set_meta_uint16(hid_t HDF_file_id, char *label, char *meta, uint16_t value);
extern int SGTK_set_meta_uint32(hid_t HDF_file_id, char *label, char *meta, uint32_t value);
extern int SGTK_set_meta_float(hid_t HDF_file_id, char *label, char *meta, float value);
extern int SGTK_set_meta_float32(hid_t HDF_file_id, char *label, char *meta, float value);
extern int SGTK_set_meta_float64(hid_t HDF_file_id, char *label, char *meta, double value);

extern int SGTK_make_group(hid_t HDF_file_id, char *group);
extern int SGTK_utc_to_tai93(int year, int month, int day, int hour, int min, int sec, int msec, double *tai93time);
extern int SGTK_tai93_to_utc(double tai93time, int *year, int *month, int *day, int *hour, int *min, int *sec, int *msec);
extern void *SGTK_malloc(int *dims, int rank, int size);
extern int SGTK_free(void *buf);
extern int SGTK_get_global_latlon(char *granule_id, float *latlon);
extern int SGTK_load_config(char *file_name);


#endif
